/*===========================================================================
//
//  callcons.S
//
//
//===========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//===========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    hmt
// Contributors: hmt,
//               Gaisler Research (Konrad Eisele<eiselekd@web.de>) (fpu support)
// Date:   1999-02-20
// Purpose:
// Description:   callcons.S
//
//####DESCRIPTIONEND####
//
//=========================================================================*/

! special treatment for CYGHWR_HAL_SPARC_FLAT case, otherwise hal_zero_bss will clear return address

  .section ".data"
  .balign 4
save_i7:      !avoid .bss (clear)
        .long 0x100000
save_o7:      !avoid .bss (clear)
        .long 0x100000

  .text
        .global cyg_hal_start
        .extern cyg_hal_start_indirect

cyg_hal_start:
        add  %sp, -112, %sp
        set save_i7,%g1
        st %i7,[%g1]
        set save_o7,%g1
        st %o7,[%g1]

        call  cyg_hal_start_indirect
        nop

        set save_i7,%g1
        ld [%g1],%i7
        set save_o7,%g1
        ld [%g1],%o7
        retl
        add  %sp, 0x70, %sp


// EOF callcons.S
